/*->c.main */


#include <stdafx.h>
#include "resource.h"



#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "flex.h"
#include "sprite.h"
#include "transform.h"
#include "bbc.h"
#include "akbd.h"


#include "wos.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "deb.h"
#include "fsx.h"
#include "timex.h"
#include "etc.h"
#include "config.h"
#include "save.h"
#include "bf.h"
#include "key.h"
#include "crc.h"
#include "pane.h"
#include "bits.h"
#include "colour.h"
#include "redraw.h"



#include "constants.h"

#include "reslink.h"
#include "mlo.h"


#include "dbox.h"


#include "main.h"




int    version=100;
int    compatability=0;
char * datestring="(15-Oct-07)";





void terminate(void)
{
 configsave();
 event(EVENT_ENDPROGRAM,NULL,0);
 scrapfinit();
 report(finittask());
 exit(0);
}




static os_error * terminatemessage(wimp_msgstr * msg,int * ack)
{
 terminate();
 USE(msg);
 USE(ack);
 return(NULL);
}


/*
static os_error * writebootfile(wimp_msgstr * msg,int * ack)
{
 char string[256];
 int  handle;

 handle=msg->data.savedesk.filehandle;
 sprintf(string,"Run %s\n",getenv("SpeakTime$Dir"));
 return(fs_write(handle,string,strlen(string)));
 USE(ack);
}

*/

static os_error * addmessages(void)
{
 os_error * err;

//          err=addmessage(writebootfile,wimp_SAVEDESK);
 err=addmessage(terminatemessage,wimp_MCLOSEDOWN);

 return(err);
}




/* open info window and pass back pointer */

/*

static os_error * infodynamic(int * menu,int * handle)
{
 os_error * err;
 static int infowhandle;

 err=NULL;

 if(menu[0]==0)
 {
  if(!infowhandle) err=createwindow(TINFO,&infowhandle);
  writeicon(infowhandle,1,wimpt_programname());
  writeiconf(infowhandle,7,"%d.%02d %s",version/100,version % 100,datestring);
  *handle=infowhandle;
 }

 return(err);
}


static os_error * infodecode(int * menu)
{
 os_error * err;

 err=NULL;


 switch(menu[0])
 {
  case 1:
         err=openspeaktime();
         break;

  case 2:
         terminate();
         break;
 }

 return(err);
}

*/



/*
static os_error * iconbar(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==iconbaricon)
 {
  if(m->bbits==2)
  {
   err=openupmenu(MINFO);
  }
  else
  {
   err=openspeaktime();
  }
 }

 return(err);

 USE(userhandle);
 USE(handle);
}




static os_error * setupmenus(void)
{
 os_error * err;

 err=addclickevent(iconbar,-2,0);

 setmenufns(MINFO,infodecode,infodynamic);
 setmenudynamic(MINFO,0);
 setmenuflags(MINFO,MFINFO);

 return(err);
}


*/

int main(int argc,char * argv[])
{ 
 os_error * err;


 setlocale(LC_ALL,".1252");

 err=inittask("SpeakerTime","SpeakerTime","!SpeakerTime",
                                      NULL,NULL,NULL);

 
 if(err)
 {
  report(err);
  exit(0);
 }


#ifdef __DEBUG
 debugenable(NULL); 
#endif


// if(!err) err=seticonbar("!SpeakTime");

 if(!err) err=resinit("<SpeakerTimeRes$Dir>");

if(err)
 {
  report(err);
  terminate();
 }


 if(!err) err=addmessages();

// if(!err) err=menulostart("<SpeakTimeRes$Dir>","Menus");
// if(!err) err=setupmenus();

 if(!err) err=configinit();


 event(EVENT_RUNPROGRAM,NULL,0);

 err=openspeaktime();

 if(err)
 {
  report(err);
  terminate();
 }


 runtask();

 return(0);

 USE(argc);
 USE(argv);

}

